\chapter{Time series modelling for Air Quality and Energy optimization}
\label{chap:metamodel}
This first chapter focuses on the building-oriented data gathered by Oze-Energies, and the introduction of statistical models and inference procedures for time-series forecasting.

We propose in Section~\ref{sec:meta:model} a  meta modelling protocol of the transient simulator TRNSYS.
We find that there is an extensive literature on building meta modelling, however only the most simple statistical models are usually presented  in the literature dedicated to energy use and efficiency in buildings.
Therefore, we compare the performance of these models with the traditional deep learning architectures for sequential data presented in the introduction, and introduce a new metamodel based on recurrent deep neural networks.
An appealing feature of the proposed model is that its training procedure allows to model multiple buildings at once.

In Section~\ref{sec:calib:optim}, we present the advantages of substituting TRNSYS for the metamodel during the calibration and optimization tasks, and demonstrate that the computation time reduction allows for the calibration of more complex buildings, that would have been prohibitive with TRNSYS.
We also describe in detail the optimization task, as well as the protocol for choosing an optimal set of usages for the buildings, leading to a reduction of up to 10\% in electric consumption.
Our end-to-end methodology is summarized in Figure~\ref{fig:bne_workflow}.

Finally, in Section~\ref{sec:air:quality}, we introduce the Air Quality analysis, and provide a first  approach to modelling indoor relative humidity.
The high uncertainty on the data and the input variables lead us to explore state space models in the next chapter.

The results presented in this chapter are adapted from the following contributions: {\em End-to-end deep meta modelling to calibrate and optimize energy consumption and comfort}, Cohen, M. Le Corff, S., Charbit, M., Champagne, A., Nozi\`ere, G, Preda, M., Energy and Buildings, Volume 250, November 2021.

\section{Energy meta modelling}
\label{sec:meta:model}
In this section, we introduce a new metamodel to predict building behaviors after a comprehensive study of several approaches from traditional RNN to a model based on a Transformer architecture \cite{Vaswani2017AttentionIA}.
The performance of this metamodel are compared both in terms of accuracy and computational efficiency with TRNSYS.

\subsection{Related works}
The building optimization literature has seen an increasing number of surrogate approaches, as recent sophisticated statistical models provide appealing solutions to be used in this context.
In \cite{Bre2020AnEM,Reynolds2018AZB}, statistical models were trained on a dataset sampled from EnergyPlus, allowing significant computational savings during optimization.
In \cite{Bre2020AnEM}, the authors proposed to combine NSGA-II with an artificial neural network metamodel, here a Feed Forward Network (FFN), in order to optimize the consumption of a $83\,\mathrm{m}^2$ house. Optimization was also conducted with the original building simulator, EnergyPlus, in order to compare both results and ensure that the FFN could be used as a substitute during optimization.
Similarly, \cite{Reynolds2018AZB} proposed a FFN based meta modelling approach to reduce up to 25\% the energy consumption in a small office building. EnergyPlus was used to sample a dataset for various zones of the building. %These simulations spread over 24 hours, and approximated the building behavior from January to March.
The metamodel was tested using a 4-week long EnergyPlus simulation with variable set point temperatures and using an alternative weather file.
An example of recurrent neural architecture as a surrogate model can be found in \cite{Ohta2020}, where the authors focused on an air-conditioning optimization problem using time series.

If these articles justify the use of metamodels, the question of which type of model to choose remains.
In an in-depth review, \cite{roman2020application} compares standard statistical models, such as polynomial regression, multivariate adaptive regression splines, Gaussian processes or Decision Trees, in the context of building performance simulation.
Artificial Neural Networks models stand out as a particularly relevant alternative, but are often presented in their most simple, time independent form, such as the FFN used in \cite{Bre2020AnEM}.
Although they may yield accurate predictions in some frameworks, these neural networks handle every time step independently, and are thus not adapted to time series problems.
They are usually substituted for their sequential counterparts, such as recurrent or convolutional based approaches, as demonstrated by the authors of \cite{SendraArranz2020ALS}. In their paper, they explored various architectures of Long Short Term Memory models, in order to predict HVAC consumption in buildings.
Therefore, designing metamodels for building calibration and optimization is likely to benefit from such recurrent and attention-based models.

Recurrent Neural Network (RNN) were first introduced as a more suited architecture for dealing with time varying input patterns \cite{Mozer1989AFB}. By replacing buffer based approaches with an updated context state, RNN are able to solve time series problems with short time dependencies, but are lackluster in problems requiring long term memory due to vanishing and exploding gradient \cite{Bengio1994LearningLD}. The Long Short Term Memory (LSTM) model proposed in \cite{Hochreiter1997LongSM} aims at bridging that gap by enforcing error flow throughout time in the network. The LSTM architecture was modified in \cite{Cho2014LearningPR} in order to simplify its implementation and improve computation times, resulting in a novel model called Gated Recurrent Unit (GRU). In parallel to these advances on recurrent architectures, Convolutional Neural Networks (CNN), rendered popular by \cite{Krizhevsky2012ImageNetCW} for image classification, have been adapted to time series problem. The approaches proposed in \cite{Jzefowicz2016ExploringTL,Kim2016CharacterAwareNL} outperformed traditional Natural Language Processing (NLP) models by replacing the embedding layer with a character-level convolutional layer. %Following this idea, \cite{Oord2016WaveNetAG} considerably improved on the speech to text state of the art, by using dilated convolutions, increasing the receptive fields of WaveNet at each layer. One year later, \cite{Oord2017ParallelWF} improved on the existing architecture by introducing Parallel WaveNet, which provided similar performance for a lower computational cost.

Recurrent and convolutional approaches coincide in that temporally close time steps data are matched together. In 2017, \cite{Vaswani2017AttentionIA} proposed an attention based approach to solve NLP tasks that consider the entire input sequence in parallel. The Transformer model is based on a self-attention mechanism, that computes an attention value for every element of a sequence with respect to all others to model their dependency. This attention mechanism allows to understand at each time step which input elements are crucial to predict the new state. This makes these networks more interpretable than their most widely-used recurrent counterparts such as LSTM or GRU networks and motivates a keen interest for such approaches to predict complex time series.

\subsection{Notation}
In the following sections, we benchmark multiple models on the following regression task:
for all $t \in \{1 \cdots T\}$, let $y_t = (\zeta_t, \tau_t)$ be the vector of observations at time $t$, such as inside temperatures in $\tau_t$, heating, cooling and ventilation consumptions in $\zeta_t$.
We compare predictions of $y_t$ from a set of inputs $u_t = (\lambda, \varphi_t, \delta_t, \psi_t)$, describing the building properties in $\lambda$, usage in $\psi_t$, occupation in $\delta_t$ as well as weather data in $\varphi_t$.
This input vector contains $d_u=34$ variables at each time step: 17 variables from $\lambda$, 7 from $\varphi_t$, 1 from $\delta_t$ and 9 from $\psi_t$.
Note that some of these properties, such as the ones contained in $\lambda$, do not vary with time.
In an attempt to keep the definition of the problem as well as the notation as simple as possible, we choose to include them in the input vector $u_t$ indexed by the time step $t$, even if they remain constant for the entirety of the time series.
A detailed list of all variables used in the following experiments is available, see Appendix~\ref{sec:metamodel_ranges}.

\subsection{Proposed benchmarks}
\label{sub:metamodel_benchmarks}
In most recent works, a great deal of research activities focused on FFN as surrogate models, see \cite{Bre2020AnEM,Magnier2010MultiobjectiveOO,Reynolds2018AZB}.
Although they may lead to interesting performance during the training phase, these fully connected architectures are not well suited for time series prediction, in particular for long time spans.
We ceased this opportunity to explore other approaches that have proven to be more relevant for solving time series tasks in the past few years.
Therefore, we decided to evaluate the go-to architectures for time series.
\begin{itemize}
	\item A LSTM model presented in details in Section~\ref{sub:metamodel}.
	\item A bidirectional GRU (BiGRU). A definition of this model can be found in \cite{Li2021BiGru}. We chose the same hyper parameters (number of layers, latent space dimensions, etc.) as for the LSTM model.
	\item A hybrid model mixing both convolutional and GRU layers (ConvGru). This model was inspired by \cite{Zhang2018ConvGru} and consists of three one dimension convolution layers, followed by three GRU layers.
	\item A Feed Forward Network (FFN) with two hidden layers, as for the one used in \cite{Bre2020AnEM}. At each time step $k$, the model computes an estimation of the observation $y_k$ based on $u_k$ only. Note that because this process is done independently for each time step, we are able to parallelize the sequence of predictions, leading to a reduced computation time. However, this also means that the model cannot infer time dependencies from the data.
	\item A Transformer model modified for inference based on long time series is also considered. The original Transformer, as well as this new model, are presented in in the following chapter.
\end{itemize}
These models have been implemented using the deep learning framework PyTorch\footnote{https://pytorch.org}, and can be found on our Github repository.\footnote{https://github.com/maxjcohen/transformer}

\subsubsection{The Transformer}
\label{sec:transformer-architecture}
The Transformer is a neural network architecture developed originally to solve Natural Language Processing (NLP) tasks.
It relies on attention mechanisms to address the lack of long term memory of LSTM models, highlighted in \cite{Zhou2021Informer} for instance.
We first present the self attention layer, then detail the full architecture of the Transformer.
In the following chapter, we discuss our modified implementation adapted for time series.

\paragraph{Self attention. }
The self attention layer aims at combining elements of the input time series $(u_1, \cdots, u_T)$ that relate to each other.
This relation is learned by the network during training, and represented during inference by the Score matrix.
Let $X = (u_1, \cdots, u_T)^\top$ the input matrix with shape $(T, d_u)$ created by stacking all time steps of the input time series vertically.
We start by computing three matrices $Q\in\mathbb{R}^{T\times d_q}$, $K\in\mathbb{R}^{T\times d_q}$ and $V\in\mathbb{R}^{T \times d_v}$ containing query and keys vectors with dimension $d_q$, as well as values vectors with dimension $d_v$ associated with each time step.
Both $d_q$ and $d_v$ are hyper parameters, set in the original paper to $d_q = d_v = 64$.
Then the score matrix, with shape $(T, T)$, represents the attention of each time step towards every other.
\begin{align*}
	Q               & = X W_q                          & \texttt{Queries} \\
	K               & = X W_k                          & \texttt{Keys}    \\
	V               & = X W_v                          & \texttt{Values}  \\
	\texttt{Scores} & = d_q^{-1/2}Q K^\top\,,
\end{align*}
where $\{W_q, W_k, W_v\}$ are parameters of the Transformer model, learned during the training procedure. Such transformations, referred to as self-attention, compares inputs with one another as the matrix $Q K^\top$ contains all dot products between entries (columns) of $Q$ and $K$. The attention is given by
$$
	Attention = \texttt{softmax}\left(d_q^{-1/2}Q K^\top\right) V\,,
$$
where the softmax function is defined, for any $z \in \mathbb{R}^d$, by
$$
	\texttt{softmax}:z \mapsto \left(\mathrm{e}^{z_1},\ldots,\mathrm{e}^{z_d}\right) /\sum_{j=1}^d \mathrm{e}^{z_j}\,.
$$
By computing the product between $Q$ and $K^\top$, we are evaluating the association between every element of $X$, regardless of their position in the time series.
This is the main contribution of the Transformer, as it allows the model to address all time steps at the same time, replacing the previous memory mechanism.
The score matrix was designed to be computed in parallel, using modern hardware, allowing for very fast computation times.
This makes for a computationally interesting alternative to RNNs, where the latent state must be computed recursively.
However, with this parallelisation comes a quadratic complexity in the time length.
While this is usually not a problem for NLP tasks, as the length of a sentence is usually small (see \cite{Proust1921} for an inconvenient truth), it is a major limitation in our case.

\paragraph{Architecture of the Transformer. }
The Transformer builds on an encoder-decoder structure, which was introduced in \cite{Cho2014LearningPR}, in order to push the model toward a meaningful, abstract representation of the data.
By dividing the model in two almost symmetrical sections - an encoder and a decoder - with a bottleneck referred to as the latent vector, the model is constrained to perform a compression of the available information.

In the Transformer, the encoder blocks are composed of a self attention layer, as defined in the previous paragraph, followed by a two-layer Feed Forward Network (FFN) with a Rectified Linear Activation Unit (ReLU, see \cite{Bai2022} for a review): $\texttt{FFN}(x) = max(0, x W_1 + b_1) W_2 + b_2$, where $\{W_1, W_2, b_1, b_2\}$ are unknown parameters learnt during training.
The decoder blocks follow the same architecture, with an additional "Encoder Decoder Attention" layer, where the attention score matrix is computed with respect to the latent vector.
In our implementation, we chose to stack $N=4$ encoder and decoder blocks, which is slightly lower that the value proposed in the original paper of $N=6$, in order to reduce the size of the model and the computation cost.
Similarly, we combine $h=4$ attention layers instead of the original $h=8$.
See Figure~\ref{fig:model_transformer} for a diagram of the full Transformer architecture.

During inference, the Transformer generates the latent vector in an autoregressive manner, by recursively computing predictions with the decoder section.
In order to speed up evaluations of the model during the training phase, the ground truth is directly fed to the decoder, while future observations are masked.
All  parameters are then estimated using gradient descent.

\begin{figure}[htpb]
	\centering
	\caption{The original Transformer contains $N$ encoder and decoder layers, each one combining $h$ self attention blocks.}
	\includegraphics[width=0.4\linewidth]{images/metamodel/transformer_architecture.png}
	\label{fig:model_transformer}
\end{figure}

\subsubsection{The Transformer adapted to Time Series}
Because of its quadratic complexity in the time dimension, the Transformer is too computationally expensive for our use case, as time series can span up to 672 hours long.
However, the self attention mechanism being appealing to take into account long-term dependencies, we propose to adapt the Transformer architecture for long time series.
In the proposed benchmark, the input sequence of the attention layers is decomposed using a rolling window, and each split is treated independently and in parallel.
Let $p$ be the size of this attention window, and $\kappa$ a stride, we define a set of input matrices as follows: for all $0 \leq i \leq \lfloor (T - p - 1) / \kappa \rfloor$,
$$x_i = (u_{i \kappa + 1}, \cdots, u_{i \kappa + p + 1})^\top\,.
$$
Following the same equations as for the original Transformer, presented in Section~\ref{sec:transformer-architecture}, we compute the attention for each subsection of the input time series, and concatenate the result.

In addition to greatly reducing the computation time for long sequences, we introduced a local attention mechanism which improved the model performance.
After training our model on the metamodel dataset, see Section~\ref{sec:dataset}, we were able to produce attention maps presented in Figure~\ref{fig:attention_map}.

\begin{figure}[htpb]
	\centering
	\caption{Attention map for building behavior prediction, for two consecutive weeks.
	Each pixel corresponds to a scalar value in the attention map produced by the Transformer model during inference, with darker colors indicating lower values and brighter colors higher values.
	We can identify day and night cycles, as well as week and weekend.}
	\includegraphics[width=0.4\linewidth]{images/metamodel/attentionmap.png}
	\label{fig:attention_map}
\end{figure}

\subsection{Our metamodel}
\label{sub:metamodel}
%Our metamodel is a function $f_{\theta}: (h_{t-1},u_t) \mapsto f_\theta(h_{t-1}, u_t) = y_t + \epsilon_t$...
Our metamodel is built following a classical recurrent mechanism. We assume that the observations can be modeled using a sequence of hidden states $(h_t)_{t\geq 0}$. At each time step $t$, the observations are defined as random transformations of the input $u_t$ and the hidden state $h_{t-1}$ depending on the past values $(u_1,\ldots,u_{t-1})$. We use as a backbone a many to many RNN architecture, and denote by $h_t^\ell$ and $x_t^\ell$ the hidden state and input of layer $1 \leq \ell \leq L$ at time step $t$, with the additional convention $x_t^0 \equiv u_t$.
The hidden state is traditionally initialized as the zero vector, $h_0^\ell \equiv 0$ for all $1 \leq \ell \leq L$.

In the original and most simple definition of a RNN, the hidden state is computed recursively as $h_t^\ell = \tanh(W_{ih}^\ell x_t^\ell + W_{hh}^\ell h_{t-1}^\ell + b_h^\ell)$, where $W_{ih}$, $W_{hh}$ and $b_h$ are the weight matrices and bias learned during training, and initialized with random values. Our metamodel is based on a LSTM architecture and replaces the update of the hidden state by the following state equations:
\begin{align*}
	\Gamma_i^\ell & = \sigma(W_{xi}^\ell x_t^\ell + W_{hi}^\ell h_{t-1}^\ell + b_i^\ell)\,, \\
	\Gamma_f^\ell & = \sigma(W_{xf}^\ell x_t^\ell + W_{hf}^\ell h_{t-1}^\ell + b_f^\ell)\,, \\
	\Gamma_o^\ell & = \sigma(W_{xo}^\ell x_t^\ell + W_{ho}^\ell h_{t-1}^\ell + b_o^\ell)\,, \\
	\tilde c_t    & = \tanh(W_{xc}^\ell x_t^\ell + W_{hc}^\ell h_{t-1}^\ell + b_c^\ell)\,,  \\
	c_t^\ell      & = \Gamma_f^\ell * c_{t-1}^\ell + \Gamma_i^\ell * \tilde c_t\,.          \\
	h_t^\ell      & = \Gamma_o^\ell * \tanh c_t^\ell\,.
\end{align*}
where $x_t^\ell \equiv h_t^{\ell-1}$ is the hidden state computed in the previous layer.
An additional fully connected layer is added on top of the RNN architecture, following results presented in \cite{SendraArranz2020ALS}, to mobtain the observation model:
$$y_t = \sigma (W_y h_t^L + b_y) + \varepsilon_t\,,$$
where $\sigma$ is the sigmoid activation function $\sigma: x \mapsto (1 + e^{-x})^{-1}$ and where $(\varepsilon_t)_{t=1}^T$ are independent centered Gaussian variables with covariance matrix $\Sigma_y$.
%by explicitly computing relevance and update gates $\Gamma_r$ and $\Gamma_u$. At each time step, a new hidden state candidate is computed from the previous hidden state and input, and replaces the current hidden state following the update gate.
% $*$ represents the element-wise product.
The architecture is represented in Figure~\ref{fig:architecture}. The unknown parameters to be estimated during the training phase of the metamodel are
$$
	\theta = \left\{\left(W_{xi}^\ell,W_{hi}^\ell,W_{xf}^\ell,W_{hf}^\ell,W_{xo}^\ell,W_{ho}^\ell,W_{xc}^\ell,W_{hc}^\ell,W_y,b_{i}^\ell,b_{f}^\ell,b_{o}^\ell,b_{c}^\ell,b_y\right)_{1\leq \ell \leq L}\right\}\,.
$$
The model is trained to produce accurate predictions by tuning its parameters $\theta$, usually referred to as weights, through an iterative back propagation algorithm, where predictions are compared to the ground truth $y_t$.
Since we choose the Mean Square Error as a cost function, the covariance matrix $\Sigma_y$ is not estimated during training.



\begin{figure}[htpb]
	\centering
	\caption{Our metamodel architecture (left), and a detailed LSTM cell (right). The LSTM cell improves on the classic RNN by introducing a cell state $c_t$ supposed to carry long term memory, without additional alterations, throughout the sequence. The three input gate $\Gamma_i$, forward gate $\Gamma_f$ and output gate $\Gamma_o$ determine whether information in both hidden state $h_k$ and cell state $c_k$ should be carried away or discarded.}
	\includegraphics[width=0.35\textwidth]{images/metamodel/rnn.png}
	\includegraphics[width=0.35\textwidth]{images/metamodel/LSTM_cell.png}
	\label{fig:architecture}
\end{figure}

%An inference is conducted by iteratively computing the hidden states, layer after layer, from the input vector $u_k$, in our application the concatenation of the building environment, namely $(W_k, O_k, I_k)$, as well as the building physical properties $\theta_{building}$.
%We then retrieve the output vector $y_k$, corresponding to a prediction of $Y_k$, the indoor temperature and consumptions.


%During the training step, we sample input and output pairs from the dataset and process the model inference from the input.
%The error between the predicted output and the ground truth vector is back propagated throughout the layers, and back in time, in order to update the weights matrices and bias in $\theta_{meta}$.
%As our model is differentiable, minimizing the loss function is a simple case of gradient descent.



\subsection{Dataset sampling}
\label{sec:dataset}
The training dataset is sampled by exploring the input space of the simulator.
We chose TRNSYS as it was the simulator used by Oze-Energies, but any simulator can be used to train the metamodel. We define ranges for each input variable in $\lambda$ and $(\psi_k)_{k\geq 0}$ with the help of energy managers, such as highest and lowest scheduled temperature, or the earliest and latest hours of arrival of occupants, see the appendices for a complete list of these ranges.
Because our dataset aims at capturing multiple buildings, these ranges are not centered around a specific set of variables, but rather cover all possible values across our cluster of buildings.
In addition, real weather data $(\varphi_k)_{k\geq 0}$ acquired between June and August 2020 around the Parisian area where used to obtain a dataset consistent with the real buildings.

%As discussed in the previous section, some related papers use Latin Hypercube sampling, introduced in \cite{McKay2000ACO}, to form their dataset.
In our numerical experiments, we chose a uniform sampling method over the ranges for each building and weather variable.
This allows us to easily split the dataset uniformly into training and testing sets, which is crucial to validate the metamodel.

%During this step, daily values defined in the appendix are converted to a time series whose value changes with every day.
A total of 15,000 training examples were sampled, an example being 672 hours i.e. 28 days, which we will refer to as to as a month.
During the training phase, the parameters of each metamodel described in Section~\ref{sub:metamodel_benchmarks}, and called $\theta$ in the detailed case of the RNN approach, are estimated based on this dataset.
The metamodels compared in this section are defined with a latent dimension of $d_{emb} = 64$ and a total of $L=4$ layers.
% These values were obtained through a grid search, see the supplementary material for additional information.
% Other hyper parameters, such as learning rate dropout, number of epochs or batch size, were chosen empirically.
Hyper parameters, such as learning rate, dropout, number of epochs or batch size, were chosen by cross validation.

%In order to chose the most efficient network, we ran a Grid Search for the Transformer model to set the hyperparameters, allowing us to decide on various dimensions such as the latent vector dimension or the number of layers. For instance, we trained four networks with different latent dimensions, and settled on a compromise between computation time and accuracy by setting the latent dimension to 64 (see the supplementary material for additional information). Other Hyper Parameters, learning rate, dropout, number of epochs to train or batch size among others, were chosen empirically.

\subsection{Training}
\label{sec:training}
During training, for each example, we compute the Mean Squared Error (MSE) loss, and combine consumption and temperature errors:
\begin{align*}
	\mathrm{MSE_T} = \frac{\sum_{t=1}^T (\tau_t - \widehat \tau_t)^2}{\sum_{t=1}^T (\tau_t - \overline \tau)^2}\quad\mathrm{and} & \quad
	\mathrm{MSE_Q} = \frac{\sum_{t=1}^M (\zeta_t - \widehat \zeta_t)^2}{\sum_{t=1}^M (\zeta_t - \overline \zeta)^2}                                                \\
	\mathrm{loss} = \beta \mathrm{MSE_T}                                                                                         & + (1 - \beta) \mathrm{MSE_Q}\,,
\end{align*}
where $\bar \tau = T^{-1}\sum_{t=1}^T \tau_t$, $\bar \zeta = T^{-1}\sum_{t=1}^T \zeta_t$ and $(\hat \tau_{1:T}, \hat \zeta_{1:T}) = f_\texttt{building}(\lambda, \psi_{1:T}, \delta_{1:T}, \varphi_{1:T})$ and $f_\texttt{building}$ are all the architecture proposed in the previous sections.
In the experiments below, as the inside temperatures and all consumptions are normalized, we chose the non informative value $\beta=0.5$.
We chose the Adam optimizer \cite{Kingma2015AdamAM} and all simulations were computed on a single 1080TI GPU card.
Visuals sample of the metamodel predictions are available, see Appendix~\ref{sec:additional_illustrations}.

\subsection{Validation}
Validation is essential to identify any potential overfit of the model on the training dataset.
In this study, we implement a traditional cross-validation, whereby the dataset is split into $k$ folds, and the model is trained on the $k-1$ first folds and evaluated on the last.
We average this validation score by iteratively changing the validation fold, as detailed by the authors of \cite{Seyedzadeh2020MachineLM}, with $k=5$.
This method ensures that our model is always evaluated on unseen data, which demonstrates its generalization capability and avoids any potential bias of the validation split.
Table~\ref{table:train} displays the mean values and standard deviations of the loss function of this cross validation at the end of the training procedure.
The table also displays the mean squared error $\mathrm{MSE_T}$ (resp. $\mathrm{MSE_Q}$) on the temperatures (resp. consumptions) only, as well as these same metrics computed only during occupation time: $\mathrm{MSE_T^{occ}}$ and $\mathrm{MSE_Q^{occ}}$.
For a global consumption evaluation, we compute the absolute relative error on the cumulative consumptions $\Delta_{Q^{\mathrm{Tot}}}$.
% = |Q^{\mathrm{Tot}} - \hat Q^{\mathrm{Tot}}| / Q^{\mathrm{Tot}}$. %In addition, the coefficients of determination (rescaled mean squared errors relative to the target data) of the temperatures $R^2_T$ and consumptions $R^2_Q$ are given. These coefficients of determination are computed with the Python function {\em sklearn.metrics.r2\_score}.

\begin{table}
	\caption{Metrics (means and standard deviations) of the metamodels on the validation splits. The best mean values are displayed in bold (the lowest losses and mean squared errors). $\mathrm{Time}$ is the computation time to run a single simulation through the network, and was estimated by averaging 100 inferences. Our selected architecture is detailed in Section~\ref{sub:metamodel}, and achieves the best performance on all metrics, while still being on par with most models in computation time.}
	\label{table:train}
	\centering
	\resizebox{\textwidth}{!}{
		\begin{tabular}{ cccccc }
			\hline
			                                                & BiGRU            & Transformer      & Ours                     & ConvGru          & FFN              \\
			\hline
			$\mathrm{Loss}$ \;\;\;\;\;($\times 10^{-4}$)    & $2.05\;  (1.61)$ & $2.72 \; (2.88)$ & $\textbf{1.65  (1.47)}$  & $2.26 \; (2.04)$ & $90.5 \; (41.1)$ \\
			$\mathrm{MSE_T}$ \;\;($\times 10^{-5}$)         & $1.00\;  (1.53)$ & $1.49 \; (2.75)$ & $\textbf{0.820  (1.44)}$ & $1.20 \; (2.05)$ & $39.5 \; (39.7)$ \\
			$\mathrm{MSE_Q}$ \;\;($\times 10^{-4}$)         & $3.84\;  (2.05)$ & $4.12 \; (3.01)$ & $\textbf{2.75  (1.72)}$  & $3.53 \; (1.77)$ & $172  \;(60.2)$  \\
			$\mathrm{MSE_T^{occ}}$ ($\times 10^{-5}$)       & $4.60\;  (7.16)$ & $6.56 \; (12.2)$ & $\textbf{3.79  (6.81)}$  & $5.89 \; (9.91)$ & $176  \;(189)$   \\
			$\mathrm{MSE_Q^{occ}}$  ($\times 10^{-4}$)      & $1.45\;  (1.00)$ & $2.07 \; (1.80)$ & $\textbf{1.22  (0.878)}$ & $1.85 \; (1.23)$ & $113  \;(50.8)$  \\
			$\Delta_{Q^{\mathrm{Tot}}}$  ($\times 10^{-3}$) & $4.03\;  (11.7)$ & $20.1  (12.4)$   & $\textbf{2.46 (12.0)}$   & $14.9 \; (16.2)$ & $182 \; (68.8)$ \\
			$\mathrm{Time}\;\;\;\;\; (\times 10^{-2}s)$     & 6.46             & 4.52             & 6.51                     & 6.77             & \textbf{0.341}   \\
			\hline
		\end{tabular}}
\end{table}

\section{Energy Optimization in real buildings}
\label{sec:calib:optim}
The experiments conducted in this thesis to analyze the performance of the trained metamodel focused on the optimization of two buildings in the Parisian region.
Each one is represented by a single thermal zone.

\begin{itemize}
	\item Stanley is a $18,512\, m^2$ building. It is delimited by four vertical walls of dimension $2,314\, m^2$, $1,917\, m^2$, $2,123\, m^2$ and $1,725\, m^2$, as well as a roof and ground of dimension $2,304\, m^2$. The main insulator is a $10\, cm$ layer of polystyrene. It was built in 1983.
	\item Livingstone is a $13,594\, m^2$ building, including 4 vertical walls with respective areas $1,678\, m^2$, $1,274\, m^2$, $1,281\, m^2$ and $1,252\, m^2$, a horizontal roof and a horizontal ground of dimension $4,653\, m^2$ and $4,286\, m^2$. The main insulator is a $8\, cm$ layer of polyurethane. It was built in 2006.
	      %\item Tropical is $5,916\, m^2$ building, including 5 walls of dimension $632\, m^2$, $283\, m^2$, $394\, m^2$, $152\, m^2$ and $144\, m^2$. Both roof and ground have a surface of $1479\, m^2$. Similarly as Livingstone, the insulator is a $8\, cm$ layer of polyurethane. Tropical was built in 1991.
\end{itemize}

Based on a commonly used rule, it is assumed that $2/3$ of the full area is occupied by people. Assuming that each occupant requires $12\, m^2$, this allows to set the initial values for the number of occupants and the number of PCs (set to 1.2 times this value) in the building during occupancy hours. These values are assumed to be known and fixed and used to sample the training dataset.

\subsection{Calibration}
During the training phase, metamodel parameters are estimated by minimizing the loss function on the simulated dataset which corresponds to various configurations associated with choices of $\lambda$ and $(\psi_k, \varphi_k)_{1\leq k\leq T}$.
Because this dataset is sampled from a simulation model, we trained the metamodel ignoring real building related noise and measurement errors.
Additionally, both TRNSYS and our metamodel require an estimate of the parameters $\lambda$ that cannot be properly identified for each building, especially without any site work.
By comparing the metamodel predictions to real historic data during the calibration phase, we search for a set of building related parameters that best match reality.
During this step, the weights $\theta$ of the metamodel are frozen, meaning that we no longer update each weight matrix of the neural network.

We can compute, for each given set of input parameters $\lambda$ and $(\psi_k, \varphi_k)_{1\leq k\leq T}$, the difference between estimated and real historical data.
Goodness of fit of the model is measured with by combining two calibration criteria toward temperature and consumption, as presented in \ref{eq:calib}.
Following the performance evaluation criteria in \cite{Ajib2018DatadrivenBT}, we define the normalized Mean Square Error for both:
\begin{align*}	\mathcal{L}^\texttt{calib}_\texttt{temperature}(\tau, \hat \tau) & = \frac{\sum_{t=1}^T (\tau_t - \hat \tau_t)^2}{\sum_{t=1}^T (\tau_t - \bar \tau)^2}\,,     \\%\forall \tau, \hat \tau \in \mathcal{T}\,, \\
              \mathcal{L}^\texttt{calib}_\texttt{energy}(\zeta, \hat \zeta)    & = \frac{\sum_{t=1}^T (\zeta_t - \hat \zeta_t)^2}{\sum_{t=1}^T (\zeta_t - \bar \zeta)^2}\,,
              %\forall \zeta, \hat \zeta \in \mathcal{Z}\,,\text{where} \\
\end{align*}
where
$$\bar \tau = T^{-1}\sum_{t=1}^T \tau_t\;, \bar \zeta = T^{-1}\sum_{t=1}^T \zeta_t\;, \text{and}\; (\hat \tau_{1:T}, \hat \zeta_{1:T}) = f_\texttt{building}(\lambda, \psi_{1:T}, \delta_{1:T}, \varphi_{1:T}).$$

Because this is a non differentiable problem, the cost function cannot be minimized using a stochastic gradient descent algorithm as in the training step; instead we use the CMA-ES algorithm \cite{Hansen2016TheCE}, an evolutionary algorithm designed to solve constrained non-convex optimization problems.
In our experiments, the variables we adjust for fitting are constrained by the same ranges defined in the data sampling section.
The algorithm is implemented by the author of the paper in the pycma library.\footnote{https://github.com/CMA-ES/pycma}

Following traditional methodology in building calibration, we measure the performance of the calibrated model with the Mean Bias Error ($\mathrm{MBE}$) and Coefficient of variation of the Root Mean Square Error ($Cv(\mathrm{RMSE})$) criteria.
For any sequence of temperature $(\tau_t)_{1\leq t\leq T}$ associated with predictions $(\hat \tau_t)_{1\leq t \leq T}$, these quantities are defined as follows:
\begin{align}
	\mathrm{MBE}_T (\%) & = 100\frac{\sum_{t=1}^T{\left(\tau_t - \hat \tau_t\right)}}{\sum_{t=1}^T{\tau_t}}\,, \quad
	Cv(\mathrm{RMSE})_T (\%) = \frac{100}{\bar \tau} \left( \frac{\sum_{t=1}^T{(\tau_t-\widehat{\tau}_t)^2}}{T}\right)^{1/2}\,. \label{eq:mbe}
\end{align}
The criteria $\mathrm{MBE}_Q$ and $Cv(\mathrm{RMSE})_Q$ are computed similarly for consumptions instead of temperature.

In a detailed review of calibration methods, the authors of \cite{Fabrizio2015MethodologiesAA} have gathered the international recommended ranges regarding these criteria, when validating a calibrated model.
Regardless of the simulation program, the $Cv(\mathrm{RMSE})$ should fall within $\pm 20\%$, and the $\mathrm{MBE} \pm 5\%$ when considering hourly calibrations.
As shown in Table~\ref{tab:calib}, our results for both consumptions and indoor temperatures calibration are well within these guidelines.

Calibration was run for both the metamodel and TRNSYS for a maximum of 3 hours.
We chose the non informative value $\beta = 0.5$ for Equation~\ref{eq:calib}.
As shown in Table~\ref{tab:calib}, we can achieve satisfactory results for Stanley in this timespan, as both model converge to close values for both the $Cv(\mathrm{RMSE})$ and $\mathrm{MBE}$.
Figure~\ref{fig:calib_comparison_stanley} displays both models calibration results, compared to real data.
On the other hand, TRNSYS calibration of Livingstone is sensibly below the results obtained with the metamodel, as calibration did not converge in the available time, see Figure~\ref{fig:calib_convergence}.
The calibration of the metamodel reached convergence but with a tremendous number of epochs, that would have required to run TRNSYS for about 10 hours in order to get similar performance.
As a comparison, we calibrated the metamodel for the same number of epochs as TRNSYS, and obtained similar results.
This experiment comforts the idea that TRNSYS and the metamodel behave similarly after the calibration step, but the much shorter computation time of the metamodel allows us to better calibrate complex buildings, such as Livingstone.
See Figure~\ref{fig:calib_comparison_livingstone} for a visualization of the TRNSYS and metamodel calibration after one hour.

\begin{table}[htpb]
	\centering
	\caption{Calibration metrics for Stanley and Livingstone buildings, see \ref{eq:mbe}.
		Convergence is reached for Stanley after $300$ iterations, which is not enough for Livingstone, as displayed in Figure~\ref{fig:calib_convergence}.
		This table demonstrates that the metamodel and TRNSYS perform similarly when calibrated for the same number of iterations, although the metamodel is much faster.
		Additionally, only the metamodel is able to reach convergence for Livingstone in a reasonable time frame.}

	\label{tab:calib}
	\resizebox{\textwidth}{!}{
		\begin{tabular}{*7c}
			                  & $\mathrm{MBE}_Q$ & $Cv(\mathrm{RMSE})_Q$ & $\mathrm{MBE}_T$ & $Cv(\mathrm{RMSE})_T$ & Iterations & Computational time \\
			\hline
			{\bf Stanley}     &                  &                       &                  &                       &            &                    \\
			Metamodel         & -0.627           & {\bf 11.0}            & 0.134            & {\bf 1.20}            & 300        & 2mn                \\
			TRNSYS            & -0.409           & 12.1                  & -0.264           & 1.24                  & 300        & 3h                 \\
			\hline
			{\bf Livingstone} &                  &                       &                  &                       &            &                    \\
			Metamodel         & -0.690           & {\bf 14.2}            & -0.0551          & {\bf 1.29}            & 10000      & 1h                 \\
			Metamodel         & -0.574           & {\bf 14.2}            & -0.413           & 1.95                  & 300        & 2mn                \\
			TRNSYS            & -1.08            & 15.8                  & 0.156            & 1.96                  & 300        & 3h                 \\
		\end{tabular}
	}
\end{table}

\begin{figure}[htpb]
	\centering
	\caption{Calibration cost evolution for the metamodel and TRNSYS (see \ref{eq:calib}), on Livingstone and Stanley. Both models were calibrated for 300 epochs, which is enough to reach convergence for Stanley, but not Livingstone.}
	\includegraphics[width=\textwidth]{images/calib-optim/calib_hist.jpg}
	\label{fig:calib_convergence}
\end{figure}

\begin{figure}[htpb]
	\centering
	\caption{Consumption and temperature simulations after calibration, for both the metamodel and TRNSYS, for Stanley.}
	\includegraphics[width=0.95\textwidth]{images/calib-optim/calib_stanley_comp_elec.png}
	\includegraphics[width=0.95\textwidth]{images/calib-optim/calib_stanley_comp_t_int.png}
	\label{fig:calib_comparison_stanley}
\end{figure}

\begin{figure}[htpb]
	\centering
	\caption{Consumption and temperature simulations after calibration, for both the metamodel and TRNSYS, for Livingstone.}
	\includegraphics[width=0.9\textwidth]{images/calib-optim/calib_livingstone_comp_elec.png}
	\includegraphics[width=0.9\textwidth]{images/calib-optim/calib_livingstone_comp_t_int.png}
	\label{fig:calib_comparison_livingstone}
\end{figure}

\paragraph{Validation.}
\label{calib:validation}
The metamodel will assist the decision process for building management by simulating thermal behavior of future weeks.
Because the calibration process requires real data, the metamodel is calibrated on several past weeks, in order to capture the real building behavior in a situation as close as possible to the future period we aim to match.

We validate the calibration phase using two successive weeks, by applying the calibrated settings to the two following weeks, with fresh weather data, and compare the results to the true observed values.
The results are displayed in Figure~\ref{fig:calib_validation} and display encouraging results, as the simulation of the metamodel on the two unseen weeks is able to match most trends is both consumption and indoor temperature.

\begin{figure}[htpb]
	\centering
	\caption{Consumption and temperature simulations after calibration on two weeks (top), simulation on the two following weeks for the same parameters (bottom), for Stanley. Although curves for the validation weeks are not matched perfectly, the metamodel is able to capture most trends of both consumption and indoor temperature. The remaining difference can be explained by the absence of real building usage settings $\psi$ for the calibration week. This experiment comforts our assumption that the calibration step leads to a correct estimation of building parameters $\lambda$.}
	\includegraphics[width=0.85\textwidth]{images/calib-optim/valid_stanley_week1_elec.png}
	\includegraphics[width=0.85\textwidth]{images/calib-optim/valid_stanley_week1_tint.png}
	\includegraphics[width=0.85\textwidth]{images/calib-optim/valid_stanley_week2_elec.png}
	\includegraphics[width=0.85\textwidth]{images/calib-optim/valid_stanley_week2_tint.png}
	\label{fig:calib_validation}
\end{figure}

\subsection{Optimization}
After a successful calibration, the metamodel is supposed to have correctly estimated building parameters $\lambda$, enabling it to accurately reproduce the thermal exchanges of the real building, as confirmed by the validation step.

The parameters $(\psi_k)_{1\leq k \leq T}$ associated with the HVAC system can then be optimized for a given set of weather data $(\varphi_k)_{1\leq k \leq T}$.
The optimization tasks consists in finding a set a usage related parameters that reduce consumption while keeping the same level of comfort.
Optimizing energy consumption requires minimizing two conflicting objectives, making it impossible to find a solution that optimizes both objectives simultaneously.
Instead, we search for optimal compromises between energy consumption and comfort, and plot each proposition to form a Pareto front, see Figure~\ref{fig:pareto}.
Combinations of energy consumption and comfort are unreachable below the Pareto front, and suboptimal above; we always aim at sampling points at the intersection.
Indeed, for any such optimal compromise, we can always get a higher level of comfort, for the price of a higher consumption.
The consumption criteria is the energy load during the month; the comfort criteria is the gap between indoor temperature and a constant reference temperature $T^*$:
\begin{align*}
	\mathcal{L}^\texttt{optim}_\texttt{temperature}(T^\star, \tau) & = \sum_{t \in T_\mathrm{Occ}} (T^\star - \tau_t)^2\,, \\%\forall \tau \in \mathcal{T}\,, \\
	\mathcal{L}^\texttt{optim}_\texttt{energy}(\zeta)              & = \sum_{t=1}^T \zeta_t^2\,,
\end{align*}
with
$$
	(\hat \tau_{1:T}, \hat \zeta_{1:T})                                 = f_\texttt{building}(\lambda, \psi_{1:T}, \delta_{1:T}, \varphi_{1:T})\,,
$$
where $T^*=22.5^{\circ}C$ and $T_{\mathrm{occ}}$ is a subset of the daytime hours, where the building is considered to be occupied and the target temperature should be met.
Following recent works in building energy optimization, we search for a set of optimal parameters using NSGA-II, see \cite{Deb2000AFE}, another evolutionary algorithm, but adapted to multi objective problems.
An implementation can be found in the Pygmo\footnote{https://esa.github.io/pygmo2/} library.
We run the optimization for 3000 iterations (2 hours).
Results can be viewed as a Pareto front which is given in Figure \ref{fig:pareto} for the second month used in the calibration process.
As observed during calibration, this process can take a colossal number of iterations before achieving satisfactory results, once again justifying the use of a much faster metamodel.
The predicted time series associated with the BMS parameters selected in Figure~\ref{fig:pareto} are given in Figure~\ref{fig:timeseriesafteroptim}.
The relative gain, as well as the expected energy savings for both building are available in Table~\ref{tab:optim}.

\begin{table}[htpb]
	\centering
	\caption{Energy gain after optimization. Relative gain represents the energy load reduction between calibration and optimization steps, when maintaining the initial level of comfort. We then apply this coefficient to the real monthly consumption to obtain the reduction forecast in MWh. We also provide a more interesting reduction obtained by reducing the comfort criteria by $0.5^\circ\!$C.}
	\label{tab:optim}
	\resizebox{\textwidth}{!}{
		\begin{tabular}{c|cc|cc}
			            & relative gain (\%) & prevision (MWh) & relative gain / $0.5^\circ\!$ C (\%) & prevision / $0.5^\circ\!$ C (MWh) \\
			\hline
			Stanley     & 5.32               & 8.05            & 10.5                                 & 15.9                              \\
			Livingstone & 9.92               & 9.96            & 17.3                                 & 17.3
		\end{tabular}
	}
\end{table}

\begin{figure}[htpb]
	\centering
	\caption{Pareto front after optimization for the Stanley (left) and Livingstone (right) building. We select the point of closest equivalent comfort, corresponding to a 5.3\% (Stanley) and 9.9\% (Livingstone) reduction in consumption. Combinations of energy consumption and comfort are unreachable below the Pareto front, and suboptimal above; we always aim at sampling points at the intersection.}
	\includegraphics[width=0.45\textwidth]{images/calib-optim/pareto_stanley.png}
	\includegraphics[width=0.45\textwidth]{images/calib-optim/pareto_livingstone.png}
	\label{fig:pareto}
\end{figure}


\begin{figure}[htpb]
	\centering
	\caption{Consumption and temperature simulations after optimization (metamodel) for the Stanley building.} %Consumption is stopped during the night, leading to lower temperature outside occupation periods.}
	\includegraphics[width=0.75\textwidth]{images/calib-optim/optim_stanley_elec.png}
	\includegraphics[width=0.75\textwidth]{images/calib-optim/optim_stanley_tint.png}
	\label{fig:timeseriesafteroptim}
\end{figure}

\begin{figure}[htpb]
	\centering
	\caption{Our end-to-end methodology for metamodel training, calibration and optimization.}
	\includegraphics[width=0.75\textwidth]{images/metamodel/bne_workflow.png}
	\label{fig:bne_workflow}
\end{figure}

\clearpage
\section{Air quality modelling}
\label{sec:air:quality}
In the previous sections, we proposed an end-to-end methodology to optimize energy loads and improve comfort.
Because regulating indoor temperature, through heating and cooling, is by far the most energy hungry aspect of comfort, we neglected all other variables.
We now address a more complete analysis of building air quality control, and propose two initial naive approaches.
The limitations arising from these methods lead us to develop more complex strategies in the next chapter.

\subsection{Definition}
The Indoor Air Quality measures the impact of indoor air conditions on health and well being.
A wide array of chemicals and conditions are involved in its analysis, as detailed in \cite{Zhang2021LowCM}.
In this study, we constrain ourselves to the data gathered by Oze-Energies: \coo levels, relative humidity and indoor temperature.

\coo concentration in the air is measured by ppm (parts per million) varying between 360 ppm and 412 ppm in fresh air.
Indoor, it should be kept below the 1000 ppm threshold \cite{Andrew2015}, as high \coo concentrations are linked to symptoms of an air quality disease known as Sick Building Syndrome detailed in \cite{Hou2021}.
However, it is mainly impacted by the current occupation of the building, as highlighted in \cite{Madureira2016}, which is unknown to us.
Air quality regulation can still be achieved by tracking \coo evolution in the building, through sensors such as the ones described in Section~\ref{sub:sensors_counters}, and acting whenever these levels get too high.
In all following experiments regarding air quality in this thesis, we therefore consider \coo levels as a surrogate variable for the occupation of the building.

Humidity has an impact on both health and well being.
Results in \cite{Hou2021} show that a higher relative humidity in Chinese homes were associated with higher percentage of perceived moldy odor and humid air, while lower levels lead to perceived dry air.
From a health perspective, maintaining relative humidity between the recommended ranges prevents the spread of bacteria, viruses, and fungi among others, as described in the Sterling Chart in Figure~\ref{fig:airq:sterling-chart}.
Indoor humidity has been a known health hazard for quite some time, as the Bible states that living in buildings with dampness problems (‘plague of leprosy’) is dangerous to your health (Leviticus 14, 34–57).
Yet these concerns are relevant even for newly built dwellings, which may be well isolated, but still not allow for optimal relative humidity management, as showed in \cite{Rochelle2021}.

\subsection{Experiments}
In the subsequent paragraphs, we benchmark two statistical models applied to relative humidity forecast.
Consider the regression task where the objective is to estimate  the hourly indoor humidity, given by a sequence of observations $y_t$, using as inputs $u_t$, a combination of weather data as described in Section~\ref{sub:sensors_counters} and \coo levels, for $t \in \{1 \cdots T \}$.
In Figure~\ref{fig:airq:dataset} we present a visualization of this dataset.

\begin{figure}[ht]
	\centering
	\caption{Relative Humidity dataset.
	Visualization of a 4-week sample of the dataset.
	We aim at modelling indoor humidity based on the outdoor temperature, humidity (RHUM), aux indoor \coo levels.}
	\includegraphics[width=0.8\textwidth]{images/airq/air_quality_dataset.png}
	\label{fig:airq:dataset}
\end{figure}

\subsection{Deterministic neural network}
We start by evaluating a traditional deterministic neural network for time series, by using the same LSTM architecture as presented for indoor temperature and consumption in Section~\ref{sub:metamodel}.
At each time step $t > 1$, a hidden state $h_t$ and a cell state $c_t$ are computed from the inputs: $c_t, h_t = \text{LSTM}_\texttt{hidden}(u_t, h_{t-1}, c_{t-1})$, with $c_0 \equiv h_0 \equiv 0$.
Then, we apply a non linear transformation to map hidden states to observations: $y_t = \text{LSTM}_\texttt{observation}(h_t) + \epsilon_t$, where $(\epsilon_t)_{1\leq t \leq T}$ are independent identically distributed centered Gaussian random variable with fixed variance.
The parameters of the model are estimated by gradient descent, by minimizing the MSE.

Unlike the metamodel training of the previous section, the LSTM applied to relative humidity is not able to model local variations of the observations.
Although the general trend of the data was learned, hour to hour changes cannot be reconstructed by the model, as seen in Figure~\ref{fig:chap1-airq-lstm} where we compared two samples from the validation set to the corresponding prediction of the model.
Additional samples can be found in Appendix~\ref{app:airq}.
We believe that this discrepancy can be explained by external factors, not represented in the input data, such as ventilation settings, or an occupant opening a window.
In this context, it is not surprising that our model does not provide predictions perfectly matching the historic ground truth; however, when inferring future weeks, it is important to have access to a measure of the model's uncertainty.
For this reason, we turn to statistical models taking into account this uncertainty, in order to model the distribution of the observation, rather than simply providing a single prediction.

\begin{figure}[htpb]
	\centering
	\caption{Prediction of Relative Humidity given observations on two 24 hour samples.
		The neural network is able to model general trends, but fails at grasping hour to hour behaviors.
		Aggregated results on the entire validation set for the RMSE and MAE criteria can be found in Table~\ref{tab:airq:naive_comparison}.
		Additional samples can be found in Appendix~\ref{app:airq}.}
	\includegraphics[width=0.6\linewidth]{images/airq/lstm/oze_1.png}
	\includegraphics[width=0.6\linewidth]{images/airq/lstm/oze_2.png}
	\label{fig:chap1-airq-lstm}
\end{figure}

\subsection{Hidden Markov Model}
\label{sec:hmm}
We compare our initial LSTM with a discrete Hidden Markov Model (HMM), where hidden states $(z_t)_{t=1}^T$ take values in a finite set $\{1, \cdots, K\}$.
We consider that the number $K$ of states is fixed.
At each time step $t$, we assume that the observation $y_t$, conditionally on the hidden state $z_t = k \in \{1, \cdots, K\}$, is Gaussian distributed with mean $\mu_k \in \mathbb R$ and standard deviation $\sigma_k>0$.
The hidden states are modelled as a homogeneous Markov chain, characterized by the transition matrix $A$ such that for all $t > 1$, and for all $1 \leq k, j \leq K$, $p(z_t = k | z_{t-1} = j) = a_{kj}$ with $\sum_{j=1}^K a_{kj} = 1$ and $a_{kj} > 0$.
The initial probabilities are defined as $p(z_1 = k) = \pi_k$ with $\sum_{k=1}^K \pi_k = 1$ and $\pi_k > 0$.
The observations $y_{1:T}$ are independent conditionally on the hidden states $z_{1:T}$ so that
$$
	p(y_{1:T} | z_{1:T}) = \prod_{t=1}^T p(y_t | z_t).
$$
We can derive the log-likelihood expression of the complete distribution:
$$\ell(y_{1:T}, z_{1:T} ; \theta) = \sum_{t=1}^T \sum_{k=1}^K \log p(y_t; \mu_k, \sigma_k) \mathds{1}\{z_t=k\} + \sum_{t=1}^T \sum_{k=1}^K \sum_{j=1}^K \log(a_{kj}) \mathds{1} \{z_t = j, z_{t-1} = k \} + \sum_{k=1}^K \log \pi_k \mathds{1} \{z_0 = k\}\,,$$
where $\theta = \{\mu_k, \sigma_k, a_{kj}, \pi_k\}$ denote the parameters of the model, estimated through the Expectation Maximization (EM, \cite{Dempster77EM}) algorithm.

\paragraph{Evaluation protocol. }
Unlike deterministic neural networks,  HMMs allow to model the distribution of the observations easily.
One common way to approximate this distribution consists in drawing multiple samples from the trained model, and computing the associated relative humidity predictions.
From there, we can derive various metrics about the uncertainty of the model.

In order to benchmark the precision of the HMM to the neural network, we average $N=100$ independent predictions, and compute the Root Mean Squared Error (RMSE) and the Mean Absolute Error (MAE) criteria over the validation set.
Results are displayed in Table~\ref{tab:airq:naive_comparison} and are discussed in the next paragraph.

\begin{table}[htpb]
	\centering
	\caption{Comparison of RMSE, MAE and computation time of our model against the benchmarked HMM.
		This table provide aggregated results on the entire validation set.
		Mean values of the estimators are displayed along with their variance.}
	\label{tab:airq:naive_comparison}
	\begin{tabular}{llll}
		\toprule
		     & RMSE            & MAE             & Computation time \\
		\toprule
		LSTM & $0.31 \pm 0.18$ & $0.27 \pm 0.16$ & $21 ms$          \\
		HMM  & $0.46 \pm 0.19$ & $0.40 \pm 0.17$ & $99 m$           \\
		\bottomrule
	\end{tabular}
\end{table}

\subsection{Discussion}
We evaluated two statistical models on a relative humidity forecasting task.
The first one, a deterministic neural network, was able to provide good quality predictions based on the input variables, however lacked any information regarding its own uncertainty toward those predictions.
When modelling historic data, we rarely have access to all relevant input variables: we cannot simply rely on the model being correct.
In contrast, the Hidden Markov Model can be used to quantify the uncertainty, for instance by computing confidence intervals based on identical independent draws from the observation distribution.
However, because it can only model linear interactions on the latent space, we report a higher bias for the HMM than the LSTM.

The approximation quality of the neural network can be combined with the distribution modelling of the HMM.
In the next chapter, we propose two generative models with low bias on the Relative Humidity dataset, while providing uncertainty estimation through confidence intervals.
We compare two of the main approaches to parameter estimation for non linear time series models, Sequential Monte Carlo methods and Variational Inference.

\clearpage
\bibliographystyle{apalike}
\bibliography{src/chap1/references}
